Option Explicit

' Required Win16 API declarations
Declare Function FindWindow Lib "User" (ByVal lpClassName As Any, ByVal lpWindowName As Any) As Integer
Declare Function SetActiveWindow Lib "User" (ByVal hWnd As Integer) As Integer
Declare Function GetWindow Lib "User" (ByVal hWnd As Integer, ByVal wCmd As Integer) As Integer
Declare Function GetWindowText Lib "User" (ByVal hWnd As Integer, ByVal lpString As String, ByVal aint As Integer) As Integer
Declare Function GetParent Lib "User" (ByVal hWnd As Integer) As Integer

' Constant used by GetWindowWord to find next window
Global Const GW_HWNDNEXT = 2

' Constants used by FindWindowPartial
Global Const FWP_STARTSWITH = 0
Global Const FWP_CONTAINS = 1

Sub AppActivatePartial (TitleContains$, Method%)
   Dim hWndApp As Integer
   Dim nRet As Integer
   '
   ' Retrieve window handle for first top-level window
   ' that starts with or contains the passed string.
   '
   hWndApp = FindWindowPartial(TitleContains, Method)
   If hWndApp Then
      '
      ' Switch to it.
      '
      nRet = SetActiveWindow(hWndApp)
   Else
      '
      ' Alert user that request failed.
      '
      MsgBox "No matching applications found."
   End If
End Sub

Function FindWindowPartial (TitleStart$, Method%) As Integer
   Dim hWndTmp As Integer
   Dim nRet As Integer
   Dim TitleTmp As String
   '
   ' Find first window and loop through all subsequent
   ' windows in master window list.
   '
   hWndTmp = FindWindow(0&, 0&)
   Do Until hWndTmp = 0
      '
      ' Make sure this window has no parent.
      '
      If GetParent(hWndTmp) = 0 Then
         '
         ' Retrieve caption text from current window.
         '
         TitleTmp = Space(256)
         nRet = GetWindowText(hWndTmp, TitleTmp, Len(TitleTmp))
         If nRet Then
            '
            ' Clean up return string, preparing for
            ' case-insensitive comparison.
            '
            TitleTmp = UCase(Left(TitleTmp, nRet))
            '
            ' Use appropriate method to determine if
            ' current window's caption either starts
            ' with or contains passed string.
            '
            Select Case Method
               Case FWP_STARTSWITH
                  If InStr(TitleTmp, UCase(TitleStart)) = 1 Then
                     FindWindowPartial = hWndTmp
                     Exit Do
                  End If
               Case FWP_CONTAINS
                  If InStr(TitleTmp, UCase(TitleStart)) Then
                     FindWindowPartial = hWndTmp
                     Exit Do
                  End If
            End Select
         End If
      End If
      '
      ' Get next window in master window list and continue.
      '
      hWndTmp = GetWindow(hWndTmp, GW_HWNDNEXT)
   Loop
End Function

