Option Explicit

' Win16 API Declarations
Declare Function WinExec Lib "Kernel" (ByVal lpCmdLine As String, ByVal nCmdShow As Integer) As Integer
Declare Function FindWindow Lib "User" (ByVal lpClassName As Any, ByVal lpWindowName As Any) As Integer
Declare Function GetWindow Lib "User" (ByVal hWnd As Integer, ByVal wCmd As Integer) As Integer
Declare Function GetWindowWord Lib "User" (ByVal hWnd As Integer, ByVal nIndex As Integer) As Integer
Declare Function GetParent Lib "User" (ByVal hWnd As Integer) As Integer
Declare Function IsWindow Lib "User" (ByVal hWnd As Integer) As Integer
Declare Function GetModuleUsage Lib "Kernel" (ByVal hModule As Integer) As Integer

' GetWindow Commands
Global Const GW_HWNDNEXT = 2

' GetWindowWord Commands
Global Const GWW_HINSTANCE = -6
Global Const SWW_HPARENT = -8

' ShowWindow() Commands
Global Const SW_HIDE = 0
Global Const SW_SHOWNORMAL = 1
Global Const SW_SHOWMINIMIZED = 2
Global Const SW_SHOWMAXIMIZED = 3
Global Const SW_SHOWNOACTIVATE = 4
Global Const SW_SHOW = 5
Global Const SW_MINIMIZE = 6
Global Const SW_SHOWMINNOACTIVE = 7
Global Const SW_SHOWNA = 8
Global Const SW_RESTORE = 9

Function GetHWndByInst (hInstFind%) As Integer
   Dim hWndTmp%
   '
   ' Find first window and loop through all subsequent
   ' windows in master window list.
   '
   hWndTmp = FindWindow(0&, 0&)
   Do Until hWndTmp = 0
      '
      ' Make sure this window has no parent.
      '
      If GetParent(hWndTmp) = 0 Then
         '
         ' Compare passed hInst against this window's hInst.
         ' If a match, then return hWnd for current window.
         '
         If hInstFind% = GetWindowWord(hWndTmp, GWW_HINSTANCE) Then
            GetHWndByInst = hWndTmp
            Exit Do
         End If
      End If
      '
      ' Get next window in master window list and continue.
      '
      hWndTmp = GetWindow(hWndTmp, GW_HWNDNEXT)
   Loop
End Function

Function ShellAndWait (ByVal CmdLine$, ByVal CmdShow%) As Integer
   Dim hInstShell%
   '
   ' Trim any leading or trailing CmdLine spaces,
   ' and make sure CmdShow is valid.
   '
   CmdLine = Trim$(CmdLine)
   If CmdShow < SW_HIDE Or CmdShow > SW_RESTORE Then
      CmdShow = SW_SHOWNORMAL
   End If
   '
   ' Issue shell directive.
   '
   hInstShell = WinExec(CmdLine, CmdShow)
   If hInstShell >= 32 Then
      '
      ' Program executed normally!  Use Win16
      ' method of waiting for task to complete.
      '
      Do While GetModuleUsage(hInstShell)
         DoEvents
      Loop
      '
      ' Indicate success.
      '
      ShellAndWait = True
   End If
End Function

